prjOrders/Models/ErrorViewModel.cs
using System;

namespace prjOrders.Models
{
    public class ErrorViewModel
    {
        public string RequestId { get; set; }

        public bool ShowRequestId => !string.IsNullOrEmpty(RequestId);
    }
}

prjOrders/Controllers/OrdersController.cs
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using prjOrders.Models;

using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Http;
using prjOrders.Models.OrderDbContext;
using prjOrders.ViewModel.OrdersModel;
using prjOrders.Models.OrderOperation;
using BusinessLayer.OrderOperation;

namespace prjOrders.Controllers
{

    public class OrdersController : Controller
    {
        private readonly ILogger<OrdersController> _logger;
        List<OrderDTO> _orderDTOs;        
        OrderDTOHelper _orderHelper;
        OrdersRepositoryHelper _ordersRepositoryHelper;

        public OrdersController(ILogger<OrdersController> logger, OrdersRepositoryHelper ordersRepositoryModel, OrderDTOHelper orderDTOHelper)
        {
            _logger = logger;            
            _orderDTOs = new List<OrderDTO>();
            _orderHelper = orderDTOHelper;
            _ordersRepositoryHelper = ordersRepositoryModel;
        }

        public IActionResult Index()
        {
            var providers = _orderHelper.GetProvidersDTO(_ordersRepositoryHelper.GetProviders());
            var result = _orderHelper.FirstPageDTO(_ordersRepositoryHelper.StarPageOrders(), providers);
            var serchDTO = _orderHelper.SearchDTO();

            return View(result);
        }

        [HttpGet]
        public IActionResult ShowOrderInfo(int orderId)
        {
            var order = _ordersRepositoryHelper.GetOrder(orderId);

            if (order is null)
            {
                return RedirectToAction("Index");
            }
            return View(order);
        }

        [HttpGet]
        public IActionResult InputNewOrder()
        {

            var order = _orderHelper.GetOrdersDTO(_ordersRepositoryHelper.GetOrder(0));

            var orderItems = _orderHelper.GetOrderItemsDTO(_ordersRepositoryHelper.OrderItemsByOrder(order.Id));

            var providers = _orderHelper.GetProvidersDTO(_ordersRepositoryHelper.GetProviders());

            return View(_orderHelper.ViewOrders(order, orderItems, providers));
        }

        [HttpPost]
        public IActionResult SaveNewOrder(ViewOrdersInfo viewOrders)
        {
            var order = _orderHelper.GetOrderFromDTO(viewOrders.OrdersDTO);



            return RedirectToAction("ShowOrderInfo", new { orderId = _ordersRepositoryHelper.AddOrder(order) });
        }


        [HttpPost]
        public IActionResult DeleteOrder(int orderId)
        {
            _ordersRepositoryHelper.DeleteOrder(orderId);
            return RedirectToAction("Index");
        }

        [HttpPost]
        public IActionResult EditDeleteOrder(int orderItemId, ViewOrdersInfo viewOrdersInfo)
        {
            var orderItem = _ordersRepositoryHelper.GetOrderIdByOrderItemId(orderItemId);
            if (orderItem == null)
            {
                return RedirectToAction("EditOrder", new { Id = viewOrdersInfo.OrdersDTO.Id });
            }
            _ordersRepositoryHelper.DeleteOrderItem(orderItemId);
            return RedirectToAction("EditOrder", new { Id = orderItem.Id });
        }

        [HttpGet]
        public IActionResult EditOrder(int id)
        {
            var order = _ordersRepositoryHelper.GetOrder(id);

            if (order is null)
            {
                return RedirectToAction("Index");
            }

            var providers = _orderHelper.GetProvidersDTO(_ordersRepositoryHelper.GetProviders());

            var orders = _orderHelper.GetOrdersDTO(order);

            var orderItems = _orderHelper.GetOrderItemsDTO(_ordersRepositoryHelper.OrderItemsByOrder(order.Id));

            return View(_orderHelper.ViewOrders(orders, orderItems, providers));
        }


        [HttpPost]
        public IActionResult SaveEditOrder(ViewOrdersInfo viewOrdersInfo)
        {
            var order = _orderHelper.GetOrderFromDTO(viewOrdersInfo.OrdersDTO);

            var orderItems = _orderHelper.GetOrderItemFromDTO(viewOrdersInfo.OrderItemsDTO);

            _ordersRepositoryHelper.SaveChangesOrder(order);
            _ordersRepositoryHelper.SaveChangesOrderItems(orderItems);
            return RedirectToAction("EditOrder", new { id = viewOrdersInfo.OrdersDTO.Id });
        }

        [HttpPost]
        public IActionResult AddOrderItem(ViewOrdersInfo viewOrdersInfo)
        {
            var view = _orderHelper.AddOrderItem(viewOrdersInfo);

            return View("EditOrder", view);
        }

        [HttpGet]
        public IActionResult SerachOrders(ViewOrdersDTO viewOrdersDTO)
        {
            var foundOrders  = _ordersRepositoryHelper.FiltersForOrders(viewOrdersDTO.SearchDTO );
            viewOrdersDTO.Orders = foundOrders ;
            viewOrdersDTO.ProvidersDTO = _orderHelper.GetProvidersDTO(_ordersRepositoryHelper.GetProviders());
            return View("Index", viewOrdersDTO);
        }
    } 
}

prjOrders/Views/Orders/EditOrder.cshtml
@model ViewOrdersInfo
@{
    ViewData["Title"] = "Home Page";
    Layout = "_Layout";
}
<div class="text-center">
    <h1 class="display-4">Редактирование заказа</h1>
</div>

<form method="post">
    @for (int i = 0; i < Model.ProvidersDTO.Count; i++)
    {
        <input asp-for="@Model.ProvidersDTO[i].Id" type="hidden" />
        <input asp-for="@Model.ProvidersDTO[i].Name" type="hidden" />
    }

    <input asp-for="@Model.OrdersDTO.Id" type="hidden" />

    <input asp-for="@Model.OrdersDTO.ProviderName" type="hidden" />
    <div class="container-fluid mt-3">
        <div class="form-row">
            <table class="table table-sm table-hover table-bordered">
                <caption> Заказ </caption>
                <thead>
                    <tr class="d-flex">
                        <th class="text-center col-1" scope="col">ID Заказа</th>
                        <th class="text-center col-2" scope="col">Дата</th>
                        <th class="text-center col-4" scope="col">Номер</th>
                        <th class="text-center col-5" scope="col">Поставщик</th>
                    </tr>
                </thead>
                <tbody>

                    <tr class="d-flex">
                        <td class="text-center col-1">
                            <input type="text" asp-for="@Model.OrdersDTO.Id" class="form-control" value="@Model.OrdersDTO.Id" disabled />
                        </td>

                        <td class="text-center col-2">
                            <input type="date" class="form-control" asp-for="@Model.OrdersDTO.Date" />
                        </td>

                        <td class="text-center col-4">
                            <input type="text" class="form-control" asp-for="@Model.OrdersDTO.Number" value="@Model.OrdersDTO.Number" />
                        </td>

                        <td class="text-center col-5">
                            <div class="form-group">
                                <select class="form-control"
                                        onchange="onFormSelected(this.value)"
                                        asp-for="@Model.OrdersDTO.ProviderId"
                                        asp-items="@(new SelectList(Model.ProvidersDTO, "Id", "Name"))">
                                </select>
                            </div>
                        </td>
                    </tr>

                </tbody>
            </table>
        </div>
    </div>


    <div class="text-center">
        <h1 class="display-4">Редактирование информации о заказе</h1>
    </div>

    <div class="container-fluid mt-3">
        <div class="form-row">
            <table id="submissionTable" class="table table-sm table-hover table-bordered">
                <caption> Состав заказа </caption>
                <thead>
                    <tr class="d-flex">
                        <th class="text-center col-3" scope="col">Название</th>
                        <th class="text-center col-3" scope="col">Количество</th>
                        <th class="text-center col-3" scope="col">Единица</th>
                        <th class="text-center col-3" scope="col">Операции с заказом</th>
                    </tr>
                </thead>
                <tbody>
                    @for (int i = 0; i < Model.OrderItemsDTO.Count(); i++)
                    {
                        <input asp-for="@Model.OrderItemsDTO[i].Id" type="hidden" />
                        <input asp-for="@Model.OrderItemsDTO[i].OrderId" type="hidden" />
                        <tr class="d-flex" id="@("tablerow"+@i)">
                            <td class="text-center col-3">
                                <input type="text" class="form-control" asp-for="@Model.OrderItemsDTO[i].Name" value="@Model.OrderItemsDTO[i].Name" />
                            </td>

                            <td class="text-center col-3">
                                <input type="text" class="form-control" asp-for="@Model.OrderItemsDTO[i].Quantity" value="@Model.OrderItemsDTO[i].Quantity" />
                            </td>

                            <td class="text-center col-3">
                                <input type="text" class="form-control" asp-for="@Model.OrderItemsDTO[i].Unit" value="@Model.OrderItemsDTO[i].Unit" />
                            </td>

                            <td class="text-center col-3">
                                <button asp-controller="Orders" asp-action="EditDeleteOrder"
                                        class="btn btn-block btn-outline-danger " type="submit" name="editId" asp-route-orderItemId="@Model.OrderItemsDTO[i].Id">
                                    Удалить
                                </button>
                            </td>
                        </tr>
                    }

                </tbody>
            </table>
        </div>
    </div>

    <div class="row">

        <div class="col">
            <button asp-controller="Orders" asp-action="SaveEditOrder"
                    class="btn btn-block btn-outline-primary" type="submit" name="saveOrderId">
                Сохранить
            </button>
        </div>

        <div class="col">
            <button id="add" asp-controller="Orders" asp-action="AddOrderItem"
                    class="btn btn-block btn-outline-success" type="submit" name="addOrder">
                Добавить заказ
            </button>
        </div>

    </div>
    <div class="row"></div>
</form>


<script type="text/javascript">
    var counter = (Model.OrderItemsDTO.Count()+1);
    $(function () {
        $('#add').click(function () {
            $('<tr class="d-flex" id="tablerow' + counter + '"><td>' +
                '<input type="text" class="form-control" name="Name[' + counter + ']" value="" required="required" />' +
                '</td>' +
                '<td>' +
                '<input type="text" class="form-control" name="Quantity[' + counter + ']" value="" required="required" />' +
                '</td>' +
                '<td>' +
                '<input type="text" class="form-control" name="Unit[' + counter + ']" value="" required="required" />' +
                '</td>' +
                '<class="text-center col-3">' +
                '<button type="button" class="btn btn-block btn-outline-danger" onclick="removeTr(' + counter + ');">Удалить</button>' +
                '</td>' +
                '</tr>').appendTo('#submissionTable');
            counter++;
            return false;
        });
    });
    function removeTr(index) {
        if (counter > (Model.OrderItemsDTO.Count()+1)) {
            $('#tablerow' + index).remove();
            counter--;
        }
        return false;
    }
</script>

prjOrders/Views/Orders/Index.cshtml
@model ViewOrdersDTO
@{
    ViewData["Title"] = "Home Page";
    Layout = "_Layout";
}

<div class="text-center">
    <h1 class="display-4">Поиск</h1>
</div>
<form method="get">

    <div class="form-row">
        <div class="col-3">
            <label for="DateAfter" class="control-label">от</label>
            <input id="DateAfter" type="date" class="form-control" asp-for="@Model.SearchDTO.AfterDate" />
        </div>

        <div class="col-3">
            <label for="DateBefore" class="control-label">до</label>
            <input id="DateBefore" type="date" class="form-control" asp-for="@Model.SearchDTO.BeforeDate" />
        </div>

        <div class="col-3">
            <label for="OrderNumber" class="control-label">Номер заказа(поиск по маске)</label>
            <input id="OrderNumber" type="text" class="form-control" asp-for="@Model.SearchDTO.Number" />
        </div>

        <div class="col-3">
            <label for="Providers" class="control-label">Поставщики</label>
            <select multiple class="form-control"
                    
                    asp-for="@Model.SearchDTO.Providers">

                @for (int i = 0; i < Model.ProvidersDTO.Count(); i++)
                {
                    <option value="@Model.ProvidersDTO[i].Id">
                        @Model.ProvidersDTO[i].Name
                    </option>
                }
            </select>
            <div class="mt-3" >
                <button type="button" id="foo" class="btn btn-primary">
                    снять выделение
                </button>
            </div>
        </div>

       

        <div class="text-center">
            <div class="col">
                <button id="Search" type="submit" class="btn btn-primary" asp-controller="Orders" asp-action="SerachOrders">
                    Поиск
                </button>
            </div>

        </div>
    </div>
</form>

<div class="text-center">
    <h1 class="display-4">Главная страница заказов</h1>
</div>



<div class="form-row">
    <table class="table table-sm table-hover table-bordered">
        <caption> Заказы </caption>
        <thead>
            <tr class="d-flex">
                <th class="text-center col-3" scope="col">ID Заказа</th>
                <th class="text-center col-3" scope="col">Дата</th>
                <th class="text-center col-3" scope="col">Номер</th>
                <th class="text-center col-3" scope="col">Поставщик</th>
            </tr>
        </thead>
        <tbody>
            @foreach (var order in Model.Orders)
            {

                <tr class="d-flex" onclick="location.href='@Url.Action("ShowOrderInfo", "Orders", new { orderId=order.Id })'">
                    <td class="text-center col-3">
                        <input type="text" class="form-control" asp-for="@order.Id" disabled />
                    </td>

                    <td class="text-center col-3">
                        <input type="date" class="form-control" asp-for="@order.Date" disabled />
                    </td>

                    <td class="text-center col-3">
                        <input type="text" class="form-control" asp-for="@order.Number" disabled />
                    </td>

                    <td class="text-center col-3">
                        <input type="text" asp-for="@order.ProviderIdNav.Name" class="form-control" disabled />

                    </td>
                </tr>
            }
        </tbody>
    </table>
</div>
<form method="get">
    <div class="form-row">
        <div class=" text-center">
            <button  type="submit" class="btn btn-primary" asp-controller="Orders" asp-action="InputNewOrder">
                Добавить новый заказ
            </button>

        </div>
    </div>

</form>

prjOrders/Views/Orders/InputNewOrder.cshtml
@model ViewOrdersInfo
@{
    ViewData["Title"] = "Home Page";
    Layout = "_Layout";
}
<div class="text-center">
    <h1 class="display-4">Создание заказа</h1>
</div>

<form asp-controller="Orders" asp-action="SaveNewOrder" method="post">
    <input asp-for="@Model.OrdersDTO.Id" type="hidden" value="@Model.OrdersDTO.Id" />
    <div class="container-fluid mt-3">
        <div class="form-row">
            <table class="table table-sm table-hover table-bordered">
                <caption> Заказы </caption>
                <thead>
                    <tr class="d-flex">
                        <th class="text-center col-1" scope="col">ID Заказа</th>
                        <th class="text-center col-2" scope="col">Дата</th>
                        <th class="text-center col-3" scope="col">Номер</th>
                        <th class="text-center col-3" scope="col">Поставщик</th>
                        <th class="text-center col-3" scope="col">Операции с заказом</th>
                    </tr>
                </thead>
                <tbody>

                    <tr class="d-flex">
                        <td class="text-center col-1">
                            <input type="text" class="form-control" disabled />
                        </td>

                        <td class="text-center col-2">
                            <input asp-for="@Model.OrdersDTO.Date" value="@Model.OrdersDTO.Date" type="date" class="form-control" />
                        </td>

                        <td class="text-center col-3">
                            <input type="text" class="form-control" asp-for="@Model.OrdersDTO.Number" value="@Model.OrdersDTO.Number" />
                        </td>

                        <td class="text-center col-3">
                            <div class="form-group">
                                <select class="form-control"
                                        onchange="onFormSelected(this.value)"
                                        asp-for="@Model.OrdersDTO.ProviderId"
                                        asp-items="@(new SelectList(Model.ProvidersDTO, "Id", "Name"))">
                                </select>
                            </div>
                        </td>

                        <td class="text-center col-3">
                            <div class="btn-group" role="group">
                                <div class="col">
                                    <button asp-controller="Orders" asp-action="SaveNewOrder"
                                            class="btn btn-block btn-outline-primary" type="submit">
                                        Сохранить заказ
                                    </button>
                                </div>
                            </div>
                        </td>
                    </tr>
                </tbody>
            </table>
            <div />
        </div>
    </div>
</form>

prjOrders/Views/Orders/ShowOrderInfo.cshtml
@model Order
@{
    ViewData["Title"] = "Home Page";
    Layout = "_Layout";
}
<div class="text-center">
    <h1 class="display-4">Заказ</h1>
</div>

<div class="container-fluid mt-3">
    <div class="form-row">
        <table class="table table-sm table-hover table-bordered">
            <caption> Заказ </caption>
            <thead>
                <tr class="d-flex">
                    <th class="text-center col-1" scope="col">ID Заказа</th>
                    <th class="text-center col-2" scope="col">Дата</th>
                    <th class="text-center col-4" scope="col">Номер</th>
                    <th class="text-center col-5" scope="col">Поставщик</th>
                </tr>
            </thead>
            <tbody>
            
                <tr class="d-flex">
                    <td class="text-center col-1">
                        <input type="text" class="form-control" value="@Model.Id" disabled />
                    </td>

                    <td class="text-center col-2">
                        <input type="text" class="form-control" value="@Model.Date" disabled />
                    </td>

                    <td class="text-center col-4">
                        <input type="text" class="form-control" value="@Model.Number" disabled />
                    </td>

                    <td class="text-center col-5">
                        <input type="text" class="form-control" value="@Model.ProviderIdNav.Name" disabled />
                    </td>
                </tr>
             
            </tbody>
        </table>
    </div>
</div>


<div class="text-center">
    <h1 class="display-4">Информация о заказе</h1>
</div>

<div class="container-fluid mt-3">
    <div class="form-row">
        <table class="table table-sm table-hover table-bordered">
            <caption> Состав заказа </caption>
            <thead>
                <tr class="d-flex">
                    <th class="text-center col-4" scope="col">Название</th>
                    <th class="text-center col-4" scope="col">Количество</th>
                    <th class="text-center col-4" scope="col">Единица</th>
                </tr>
            </thead>
            <tbody>
     
                    @foreach (var order in Model.OrderItemIds)
                    {
                        <tr class="d-flex">
                            <td class="text-center col-4">
                                <input type="text" class="form-control" value="@order.Name" disabled />
                            </td>

                            <td class="text-center col-4">
                                <input type="text" class="form-control" value="@order.Quantity" disabled />
                            </td>

                            <td class="text-center col-4">
                                <input type="text" class="form-control" value="@order.Unit" disabled />
                            </td>
                        </tr>
                    }
          
                </tbody>
        </table>
    </div>
</div>

<div class="btn-group ">
    <div class="col-auto">
        <form method="get">
            <button asp-controller="Orders" asp-action="EditOrder" 
                    class="btn btn-block btn-outline-primary" type="submit" name="editOrder"  asp-route-id="@Model.Id">
                Редактировать заказ
            </button>
        </form>
    </div>

    <div class="col-auto">
        <form method="post">
            <button asp-controller="Orders" asp-action="DeleteOrder"
                    class="btn btn-block btn-outline-danger" type="submit" name="deleteOrder" asp-route-orderId="@Model.Id">
                Удалить заказ
            </button>
        </form>
    </div>
</div>

prjOrders/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />

    <title>@ViewData["Title"] - prjOrders</title>
    <link rel="stylesheet" asp-href-include="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" asp-href-include="~/css/site.css" />


    <script asp-src-include="~/lib/jquery/dist/jquery.min.js"></script>
    <script asp-src-include="~/lib/jquery-validation/dist/jquery.validate.js"></script>
    <script asp-src-include="~/lib/jquery-validation-unobtrusive/dist/jquery.validate.unobtrusive.js"></script>
    <script asp-src-include="~/js/editUser.js"></script>

</head>
<body class="bg">

    <header>

        <nav class="navbar navbar-dark bg-dark">
            <div class="btn-group col-md-3">
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
            </div>

            <div class="collapse navbar-collapse" id="navbarSupportedContent">
                <div class="container-fluid">
                    <ul class="nav navbar-nav">
                        <li class="nav-item ">
                            <a class="nav-link text-white" asp-area="" asp-controller="Orders" asp-action="Index">Главная страница</a>
                        </li>                      

                        <li class="nav-item dropdown text-white ">
                            <a class="nav-link dropdown-toggle  text-white" href="#" id="navbarDropdownUsersWebVersion" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                Заказы
                            </a>
                        
                                <div class="dropdown-menu " aria-labelledby="navbarDropdownUsersWebVersion">
                                    <a class="dropdown-item text-white " asp-area="" asp-controller="Orders"  asp-action="InputNewOrder">Добавление заказа</a>
                                    <div></div>
                                    <a class="dropdown-item text-white" asp-area="" asp-controller="Orders" asp-action="Index">Поиск</a>
                                </div>
                           
                        </li>
                        
                    </ul>
                </div>
            </div>
        </nav>
    </header>
    <div class="col">
        @RenderBody()
    </div>
    

        <footer class="border-top footer text-muted">
            <div class="container">
                2019 - Hello world - <a asp-area="" asp-controller="Orders" asp-action="Index">Home</a>
            </div>
        </footer>

    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @RenderSection("Scripts", required: false)
</body>
</html>